<?php
/**
 * @package SPElements
 * @subpackage SmartAddons.Helper
 * @version 2.5.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */


defined('_JEXEC') or die();
defined( 'DS' ) || define( 'DS', DIRECTORY_SEPARATOR );
define( 'SOBI_CMS', version_compare( JVERSION,'1.6.0','ge' ) ? 'joomla16' : 'joomla15' );
define( 'SOBIPRO', true );
define( 'SOBIPRO_ADM', true );
define( 'SOBI_TASK', 'task' );
define( 'SOBI_DEFLANG', JFactory::getConfig()->getValue( 'config.language' ) );
define( 'SOBI_ACL', 'adm' );
define( 'SOBI_ROOT', JPATH_ROOT );
define( 'SOBI_PATH', SOBI_ROOT.DS.'components'.DS.'com_sobipro' );
define( 'SOBI_ADM_PATH', JPATH_ADMINISTRATOR.DS.'components'.DS.'com_sobipro' );
$adm = str_replace( JPATH_ROOT, null, JPATH_ADMINISTRATOR );
define( 'SOBI_ADM_FOLDER', $adm  );
define( 'SOBI_ADM_LIVE_PATH', $adm . '/components/com_sobipro' );
define( 'SOBI_LIVE_PATH', JURI::base().'components/com_sobipro/' );

class JElementSPElements extends JElement
{
	public static function getInstance()
	{
		static $instance = null;
		if( !( $instance instanceof self ) ) {
			$instance = new self();
		}
		return $instance;
	}

	public function __construct()
	{
		static $loaded = false;
		if( $loaded ) {
			return true;
		}
		
		if(file_exists(SOBI_PATH)){
		require_once ( SOBI_PATH.DS.'lib'.DS.'base'.DS.'fs'.DS.'loader.php' );
		
		/* load all needed classes */
		SPLoader::loadController( 'interface' );
		SPLoader::loadClass( 'base.filter' );
		SPLoader::loadClass( 'base.request' );
		SPLoader::loadClass( 'base.const' );
		SPLoader::loadClass( 'base.factory' );
		SPLoader::loadClass( 'base.object' );
		SPLoader::loadClass( 'base.filter' );
		SPLoader::loadClass( 'base.request' );
		SPLoader::loadClass( 'sobi' );
		SPLoader::loadClass( 'base.config' );
		SPLoader::loadClass( 'base.exception' );
		SPLoader::loadClass( 'cms.base.lang' );
		SPLoader::loadClass( 'mlo.input' );
		SPFactory::config()->set( 'live_site', JURI::root() );
		$head =& SPFactory::header();
		$ccurl = Sobi::Url( array( 'task' => 'category.chooser', 'out' => 'html', 'treetpl' => 'rchooser' ), true );
		$ccmsg = Sobi::Txt( 'JS_SELECT_CATEGORY' );
		$cemsg = Sobi::Txt( 'JS_PLEASE_SELECT_SECTION_FIRST' );
		JHTML::_( 'behavior.modal' );
		/* load admin html files */
		SPFactory::header()->addJsFile( 'sobipro' );
		SPFactory::header()->addJsFile( 'adm.sobipro' );

		$head->addJsCode( '
			window.addEvent( "domready", function() {
					var semaphor = 0;
					var spApply = $$( "#toolbar-apply a" )[ 0 ];
					var spSave = $$( "#toolbar-save a" )[ 0 ];
					spApplyFn = spApply.onclick;
					spApply.onclick = null;
					spSaveFn = spSave.onclick;
					spSave.onclick = null;
					try {
						var spSaveNew = $$( "#toolbar-save-new a" )[ 0 ];
						spSaveNewFn = spSaveNew.onclick;
						spSaveNew.onclick = null;
						spSaveNew.addEvent( "click", function() {
							if( SPValidate() ) {
								spSaveNewFn();
							}
						} );
					} catch( e ) {}

					function SPValidate()
					{
						if( $( "sid" ).value == 0 || $( "sid" ).value == "" ) {
							alert( "'.Sobi::Txt( 'JS_YOU_HAVE_TO_AT_LEAST_SELECT_A_SECTION' ).'" );
							return false;
						}
						else {
							return true;
						}
					}
					spApply.addEvent( "click", function() {
						if( SPValidate() ) {
							spApplyFn();
						}
					} );
					spSave.addEvent( "click", function() {
						if( SPValidate() ) {
							spSaveFn();
						}
					} );
					$( "spsection" ).addEvent( "change", function( event ) {
						sid = $( "spsection" ).options[ $( "spsection" ).selectedIndex ].value;
						$( "sid" ).value = sid;
						try{
							var options = $("catid").childNodes;
								for(var i=0; i<options.length; i++){
									if(sid !=0 ){
										options[i].setStyle("display", "none");
										options[i].setProperty("disabled", "disabled");
										if(options[i].nodeName == "OPTION" && options[i].className == "section_" + sid  ){
											options[i].setStyle("display", "block");
											options[i].setProperty("disabled", "");
										}
									}else{
										options[i].setStyle("display", "block");
										options[i].setProperty("disabled", "");	
									}
								}
							
						}catch(x){
						}
						
						semaphor = 0;
					} );
					if( $( "sp_category" ) != null ) {
						$( "sp_category" ).addEvent( "click", function( ev ) {
							if( semaphor == 1 ) {
								return false;
							}
							semaphor = 1;
							new Event( ev ).stop();
							if( $( "sid" ).value == 0 ) {
								alert( "' . $cemsg . '" );
								semaphor = 0;
								return false;
							}
							else {
							url = "' . $ccurl . '&sid=" + $( "sid" ).value
				try {
					SqueezeBox.open( $( "sp_category" ), { handler: "iframe", size: { x: 700, y: 500 }, url: url });
				}
				catch( x ) {
					SqueezeBox.fromElement( $( "sp_category" ), { url: url, handler: "iframe", size: { x: 700, y: 500 } } );
				}
							}
						} );
					}
				} );
				function SP_close()
				{
					$( "sbox-btn-close" ).fireEvent( "click" );
					semaphor = 0;
				}
		' );
		$head->send();
		parent::__construct();
		$loaded = true;
		}
	}

	private function ordering( $selected = null )
	{
		$fData = array(
			null => Sobi::Txt( 'FD.SEARCH_SELECT_LABEL' ),
//			'position.asc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_POSITION_ASCENDING' ),
//			'position.desc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_POSITION_DESCENDING' ),
			'counter.asc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_POPULARITY_ASCENDING' ),
			'counter.desc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_POPULARITY_DESCENDING' ),
			'createdTime.asc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_CREATION_DATE_ASC' ),
			'createdTime.desc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_CREATION_DATE_DESC' ),
			'updatedTime.asc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_UPDATE_DATE_ASC' ),
			'updatedTime.desc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_UPDATE_DATE_DESC' ),
			'validUntil.asc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_EXPIRATION_DATE_ASC' ),
			'validUntil.desc' => Sobi::Txt( 'SEC.CFG.ENTRY_ORDER_BY_EXPIRATION_DATE_DESC' ),
			'RAND()' => JText::_( 'SOBI_MOD_RANDOM' ),
		);
		return SPHtml_Input::select( 'params[spOrder]', $fData, $selected );
	}

	public function fetchTooltip( $label )
	{
		switch ( $label ) {
			case 'SOBI_SELECT_SECTION':
				return JText::_( 'SOBI_SELECT_SECTION' );
			case 'sid':
				return JText::_( 'SOBI_SELECTED_SECTION' );
			case 'catid':
				return JText::_('SOBI_SELECT_CATEGORY');	
			case 'spOrder':
				return JText::_( 'SOBI_ORDER_BY' );
			case 'tplFile':
				return JText::_( 'SOBI_TPL_FILE' );
		}
	}

	private function tplFile( $selected = null )
	{
		if(
			!( file_exists( SOBI_PATH.'/usr/templates/front/modules/mod_sj_sobipro_entries_grid/' ) ) ||
			( count( scandir( SOBI_PATH.'/usr/templates/front/modules/mod_sj_sobipro_entries_grid/' ) ) < 3 )
		) {
			$this->installTpl();
		}
		$files = scandir( SOBI_PATH.'/usr/templates/front/modules/mod_sj_sobipro_entries_grid/' );
		$tpls = array();
		if( count( $files ) ) {
			foreach ( $files as $file ) {
				$stack = explode( '.', $file );
				if( array_pop( $stack ) == 'xsl' ) {
					$tpls[ $file ] = $file;
				}
			}
		}
		return SPHtml_Input::select( 'params[tplFile]', $tpls, $selected );
	}

	private function installTpl()
	{
		SPFs::mkDir( SOBI_PATH.'/usr/templates/front/modules/mod_sj_sobipro_entries_grid/' );
		SPFactory::Instance( 'base.fs.directory', dirname( __FILE__ ).'/tmpl/' )
			->moveFiles( SOBI_PATH.'/usr/templates/front/modules/mod_sj_sobipro_entries_grid' );
	}

	private function settings()
	{
		static $settings = null;
		if( !( $settings ) ) {
			$mid = JRequest::getVar( 'cid', JRequest::getVar( 'id', array() ) );
			if( is_array( $mid ) ) {
				$mid = $mid[ 0 ];
			}
			$params = SPFactory::db()
				->select( 'params', '#__modules', array( 'id' => $mid ) )
				->loadResult();
			$settings = new JParameter( $params );
		}
		return $settings;
	}


	public function fetchElement( $name, &$label )
	{
		if (class_exists('SPFactory')){
		if( $name == 'sid'  ) {
			$params = array( 'id' => 'sid', 'size' => 5, 'class' => 'text_area', 'style' => 'text-align: center;', 'readonly' => 'readonly' );
			return SPHtml_Input::text( 'params[sid]', $this->settings()->get( 'sid' ), $params );
		}
		if( $name == 'spOrder' ) {
			return $this->ordering( $this->settings()->get( 'spOrder' ) );
		}
		if( $name == 'tplFile' ) {
			return $this->tplFile( $this->settings()->get( 'tplFile' ) );
		}
		
		$sections = array();
		$sout = array();
		try {
			$sections = SPFactory::db()
					->select( '*', 'spdb_object', array( 'oType' => 'section' ), 'id' )
		 			->loadObjectList();
		}
	
		catch ( SPException $x ) {
			trigger_error( 'sobipro|admin_panel|cannot_get_section_list|500|'.$x->getMessage(), SPC::WARNING );
		}
		if( count( $sections ) ) {
			SPLoader::loadClass( 'models.datamodel' );
			SPLoader::loadClass( 'models.dbobject' );
			SPLoader::loadModel( 'section' );
			$sout[] = Sobi::Txt( 'SELECT_SECTION' );
			foreach ( $sections as $section ) {
				if( Sobi::Can( 'section', 'access', 'valid', $section->id ) ) {
					$s = new SPSection();
					$s->extend( $section );
					$sout[ $s->get( 'id' ) ] = $s->get( 'name' );
				}
			}
		}
		
		if( $name == 'catid' ) {
			//return $this->getCat($name );
			return $this->getCat( $this->settings()->get( 'catid' ) );
		}
		
		$params = array( 'id' => 'spsection', 'class' => 'text_area required' );
		
		$field = SPHtml_Input::select( 'params[sid]', $sout, $this->settings()->get( 'sid' ), false, $params );
		return "<div style=\"margin-top: 2px;\">{$field}</div>";
		}else{
			return  '<div style="margin: 5px 0;float: left;font-size: 1.091em;">Maybe your component (Sobipro) has been installed incorrectly. <br/>Please sure your component work properly. <br/>If you still get errors, please contact us via our <a href="http://www.smartaddons.com/forum/" target="_blank">forum</a> or <a href="http://www.smartaddons.com/tickets/" target="_blank">ticket system</a></div>';
		}
	}

	// not implemented yet
	private function getCat( $values )
	{
		$sections = array();
		$categories = array();
		$sout = array();
		try {
			$categories = SPFactory::db()
			->select( '*', 'spdb_object', array( 'oType' => 'category' ), 'id' )
			->loadObjectList();
		}
		
		catch ( SPException $x ) {
			trigger_error( 'sobipro|admin_panel|cannot_get_section_list|500|'.$x->getMessage(), SPC::WARNING );
		}
		
		if( count( $categories ) ) {
			SPLoader::loadClass( 'models.datamodel' );
			SPLoader::loadClass( 'models.dbobject' );
			SPLoader::loadModel( 'category' );
			//$sout[] = Sobi::Txt( 'SELECT_CATEGORY' );

			$_categories = array();
			$_children = array();
			foreach ($categories as $i => $category){
				$_categories[$category->id] = &$categories[$i];
			}
			foreach ($categories as $i => $category){
				$cid = $category->id;
				$pid = $category->parent;
				if (isset($_categories[$pid])){
					if (!isset($_children[$pid])){
						$_children[$pid] = array();
					}
					$_children[$pid][$cid] = $cid;
				}
			}
			
			
			$__categories = array();
			$__levels = array();
			foreach ($_categories as $cid => $category){
				$pid = $category->parent;
				if ( !isset($_categories[$pid]) ){
					$section_id = $pid;
					$queue = array($cid);
					$_categories[$cid]->level = 1;
					while ( count($queue) > 0 ){
						$qid = array_shift($queue);
						$__categories[$qid] = &$_categories[$qid];
						$__categories[$qid]->section_id =  $section_id;
						if (isset($_children[$qid])){
							foreach ($_children[$qid] as $child){
								$_categories[$child]->level = $_categories[$qid]->level + 1;
								array_push($queue, $child);
							}
						}
					}
				}
			}
			settype($values, 'array');
			$select_name = 'jform[params][' . $this->name . ']';
			$select_attr = "";
			if (isset($this->element['multiple'])){
				$select_attr .= " multiple=\"multiple\"";
				$size = $this->element['size'] ?(int) $this->element['size']: '';
				$select_attr .= " size=\"$size\"";
				$select_name .= '[]';
			}
			if (isset($this->element['css'])){
				$select_attr .= ' class="' . trim($this->element['css']) . '"';;
			} else {
				$select_attr .= ' class="inputbox"';;
			}
			$html = "<select $select_attr id=\"" . $this->id . '" name="' . $select_name . '">';
			foreach ($__categories as $cid => $category){
					$multiplier = $category->level -1;
					$indent = $multiplier ? str_repeat('- - ', $multiplier) : '';
					$value = $category->id;
					$text  = $indent.$category->name;
					$option = array(
						'label' => $text ,
						'value' => $value
					);
					$selected = in_array($value, $values) ? 'selected="selected"' : '';
					$first_css =  ($this->settings()->get('sid') == $category->section_id || $this->settings()->get('sid') == '')?'style="display:block" ':'style="display:none" disabled="disabled"';
					$html .= '<option class="section_' .$category->section_id. '" '.$first_css.' value="' . $option['value'] . '" ' . $selected . '>' . $option['label'] . '</option>';
			}
			$html .= '<select>';
			return $html;

		}
	}
}
?>