<?php
/**
 * @package Sj SlideshowII for SobiPro
 * @version 2.5.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */

defined('_JEXEC') or die;

if(!empty($entries)) {
	
	JHtml::stylesheet('modules/mod_sj_sobipro_slideshowii/assets/css/sobipro-slideshowii.css');
	if( !defined('SMART_JQUERY') && $params->get('include_jquery', 0) == "1" ){
		JHtml::script('modules/mod_sj_sobipro_slideshowii/assets/js/jquery-1.8.2.min.js');
		JHtml::script('modules/mod_sj_sobipro_slideshowii/assets/js/jquery-noconflict.js');
		define('SMART_JQUERY', 1);
	}
	JHtml::script('modules/mod_sj_sobipro_slideshowii/assets/js/jquery.cycle.all.js');
	
	ImageHelper::setDefault($params);
	
	$small_image_config=array(
		'type'			=> $params->get('imgcfgnav_type'),
		'width' 		=> $params->get('imgcfgnav_width'),
		'height' 		=> $params->get('imgcfgnav_height'),
		'quality' 		=> 90,	
		'function' 		=> ($params->get('imgcfgnav_function') == 'none')?null:'resize',
		'function_mode' => ($params->get('imgcfgnav_function') == 'none')?null:substr($params->get('imgcfgnav_function'), 7),
		'transparency'  => $params->get('imgcfgnav_transparency', 1)?true:false,
		'background' 	=> $params->get('imgcfgnav_background')
	);
	
	if($params->get('start')<=0){
		$params->set('start',0);
	}else{
		$params->set('start',$params->get('start')-1);
	}
	if($params->get('start') >= count($entries)){
		$params->set('start',count($entries)-1);
	}

	$addclass ='';
	if($params->get('themes') == 'theme1'){
		$addclass='top-left';
	}
	if($params->get('themes') == 'theme2'){
		$addclass='top-right';
	}
	if($params->get('themes') == 'theme3'){
		$addclass='bottom-left';
	}
	if($params->get('themes') == 'theme4'){
		$addclass='bottom-right';
	}
	
	$uniquied = rand().time();

?>

	<div id="sj_slideshowii_<?php echo $uniquied ;?>" class="sj-slideshowii" style="width:<?php echo ($params->get('themes') != 'theme5' )?($params->get('imgcfg_width') + $params->get('nav_width')):$params->get('imgcfg_width') ?>px;">
		<?php if($params->get('pretext') != null) { ?>
		<div class="pre-text">
			<?php echo $params->get('pretext'); ?>
		</div>
		<?php } ?>
		<div class="sl2-wrap <?php echo $params->get('themes'); ?> sl2-preload" style="height:<?php echo $params->get('imgcfg_height') ?>px;">
			<div class="sl2-items" style="width:<?php echo $params->get('imgcfg_width') ?>px; height:<?php echo $params->get('imgcfg_height') ?>px;">
				<?php $i=0; foreach($entries as $entry) { $i++;  ?>
				<div class="sl2-item <?php echo ($i==($params->get('start')+1))?'curr':'';?>">
					<div class="sl2-image" style="width:<?php echo $params->get('imgcfg_width')  ?>px; height:<?php echo $params->get('imgcfg_height')  ?>px;" >
						<a href="<?php echo $entry['url']; ?>" title="<?php echo $entry['name']['_data']; ?>" <?php echo SPSlideshowiiHelper::parseTarget($params->get('item_link_target')); ?> >
		    				<?php $img = SPSlideshowiiHelper::getSPImage($entry, $params);
    						echo SPSlideshowiiHelper::imageTag($img);?>
						</a>
					</div>
					<div class="sl2-more">
						<div class="sl2-opacity"></div>
						<?php if($params->get('item_title_display') == 1){?>
							<div class="sl2-title">
								<a href="<?php echo $entry['url']; ?>" title="<?php echo $entry['name']['_data']; ?>" <?php echo SPSlideshowiiHelper::parseTarget($params->get('item_link_target')); ?> >
									<?php echo SPSlideshowiiHelper::truncate($entry['name']['_data'], $params->get('item_title_max_characs'))?>
								</a>
							</div>
						<?php }?>
						<?php if($params->get('item_price_display') == 1 ){ ?>
							<div class="sl2-price">
								<?php echo  SPSlideshowiiHelper::getFieldValue($entry, $params->get('field_price')); ?>
							</div>
						<?php } ?>
						<?php $desc = SPSlideshowiiHelper::_cleanText(SPSlideshowiiHelper::getFieldValue($entry,$params->get('field_description')));?>	
						<?php if($params->get('item_description_display') == 1 && !empty($desc)){?>
							<div class="sl2-desc">
								<?php echo SPSlideshowiiHelper::truncate($desc, $params->get('item_desc_max_chars')); ?>
							</div>
						<?php }?>
						<?php if($params->get('item_readmore_display') == 1) {?>
							<div class="sl2-readmore">
								<a href="<?php echo $entry['url']; ?>" title="<?php echo $entry['name']['_data']; ?>" <?php echo SPSlideshowiiHelper::parseTarget($params->get('item_link_target')); ?> >
									<?php echo $params->get('item_readmore_text'); ?>
								</a>
							</div>
						<?php }?>
					</div>
				</div>
				<?php } ?>
			</div>
			<div class="sl2-slide" style="width:<?php echo ($params->get('themes') != 'theme5')?$params->get('nav_width'):$params->get('imgcfg_width') ?>px; height:<?php echo ($params->get('themes') != 'theme5')?$params->get('imgcfg_height'):$params->get('imgcfgnav_height') + 20?>px;">
				<?php if($params->get('themes') == 'theme5') {?>
					<?php if($params->get('nav_buttons_display') == 1 || $params->get('nav_image_display') == 1) {?>
					<div class="slide-opacity"></div>
					<?php }?>
					<?php if( $params->get('nav_buttons_display') == 1) {?>
					<div class="slide-previous"></div>
					<?php }?>
				<?php }?>
				<div class="sl2-slide-inner" style="width:<?php echo ($params->get('themes') != 'theme5')?$params->get('nav_width'):'auto' ?>px; height:<?php echo ($params->get('themes') != 'theme5')?$params->get('imgcfg_height'):$params->get('imgcfgnav_height') + 20?>px;right:<?php echo ($params->get('themes') == 'theme5' && $params->get('nav_buttons_display') == 0)?10:''?>px ;left:<?php echo ($params->get('themes') == 'theme5' && $params->get('nav_buttons_display') == 0)?10:''?>px;">
					<div class="slide-items">
						<?php $j =0 ; foreach($entries as $key => $entry) { $j++; ?>
						<div class="slide-item slide-item<?php echo $j; ?> <?php echo ($j==($params->get('start')+1))?'active':'';?>">
							<div class="slide-item-inner" style="height:<?php echo ($params->get('themes') != 'theme5')?(floor($params->get('imgcfg_height') / $params->get('num_item_per_page')) -30):''; ?>px;">
								<?php if($params->get('nav_image_display') == 1){?>
								<div class="slide-image" style="width:<?php echo $params->get('imgcfgnav_width')  ?>px; height:<?php echo $params->get('imgcfgnav_height')  ?>px; max-height:<?php  echo ($params->get('themes') != 'theme5')?(floor($params->get('imgcfg_height') / $params->get('num_item_per_page')) -34):''; ?>px; max-width:<?php echo ($params->get('themes') != 'theme5')?($params->get('nav_width') - 34):''?>px;" >
									<?php $img_nav = SPSlideshowiiHelper::getSPImage($entry, $params, $prefix='imgcfgnav');
										 echo	SPSlideshowiiHelper::imageTag($img_nav,$small_image_config); ?>
								</div>
								<?php }?>
								<?php if($params->get('themes') != 'theme5') {?>
								<div class="slide-more">
									<?php if($params->get('nav_title_display') == 1) {?>
									<div class="slide-title">
										<?php echo SPSlideshowiiHelper::truncate($entry['name']['_data'], $params->get('nav_limit_title'))?>
									</div>
									<?php } ?>
									<?php if($params->get('nav_price_display') == 1 ){ ?>
										<div class="slide-price">
											<?php echo  SPSlideshowiiHelper::getFieldValue($entry, $params->get('field_price')); ?>
										</div>
									<?php } ?>	
									<?php $desc_nav = SPSlideshowiiHelper::_cleanText(SPSlideshowiiHelper::getFieldValue($entry,$params->get('field_description')));?>
									<?php if($params->get('nav_desc_display') == 1){?>
									<div class="slide-desc">
										<?php echo SPSlideshowiiHelper::truncate($desc_nav, $params->get('nav_limit_desc')); ?>
									</div>
									<?php }?>
								</div>
								<?php }?>

							</div>
						</div>
						<?php } ?>
					</div>
				</div>	
				<?php if($params->get('themes') == 'theme5' && $params->get('nav_buttons_display') == 1) {?>
				<div class="slide-next"></div>
				<?php }?>
			</div>
			<?php if ($params->get('themes') != 'theme5' && $params->get('nav_buttons_display') == 1) {?>
				<div class="sl2-control <?php echo $addclass; ?>">
					<div class="sl2-ctr previous"></div>
					<div class="sl2-ctr play-pause <?php echo ($params->get('play')==1) ? 'pause' : 'play'; ?>"></div>
					<div class="sl2-ctr next"></div>
				</div>
			<?php }?>
			
		</div>
			<?php if($params->get('posttext') != null) {  ?>
			<div class="post-text">
				<?php echo $params->get('posttext'); ?>
			</div>
			<?php }?>
	</div><!--End sj-content-slideshow-->
	
	<script type="text/javascript">
	//<![CDATA[		
	jQuery(document).ready(function($){
		;(function(element){
		var $element = $(element);
		$(window).load(function(){
			$('.sl2-wrap',$element).addClass(' sl2-preload');
			setTimeout(function(){
				$('.sl2-wrap',$element).removeClass(' sl2-preload');
			},100);
		});
		
		/* slide navigation for theme 1, 2, 3, 4  
		*/
		
		
		function setSlidingTo(index, options){
			var tabs = $(options.pager);
			var tabs_holder = tabs.eq(0).parent();
			var tabs_container = tabs_holder.parent();
			if (tabs_container && tabs_holder){
				tabs_container.css({height: function(){
					return tabs_container.height();
				}});
				tabs_container.css({position: 'absolute'});
				tabs_holder.css({position: 'absolute'});
			}
			
			var viewport   = {};
			viewport.top  = 0;
			viewport.bottom = tabs_container.height();
			
			var visible   = {};
			visible.top  = viewport.top  - parseInt( tabs_holder.position().top );
			visible.bottom = viewport.bottom - parseInt( tabs_holder.position().top );
		
			var posUpdate = function(){
				visible.top  = viewport.top  - parseInt( tabs_holder.position().top );
				visible.bottom = viewport.bottom - parseInt( tabs_holder.position().top );
			};
			
			var slidingTo = function(index, d){
				if (!d){
					d = 500
				}
				if (index >= 0){
					if (index == 0){
						index = 1;
					}
					var prevTop = tabs.eq(index-1).position().top;
					if (prevTop < visible.top){
						tabs_holder.animate({
							top: '+='+(visible.top-prevTop)+'px'
						}, {
							duration: d,
							complete: posUpdate,
							queue:false 
						});
					}
				}
				if (index < tabs.length){
					if (index == tabs.length-1){
						index = tabs.length-2;
					}
					var nextBottom = tabs.eq(index+1).position().top + tabs.eq(index+1).height();
					if (nextBottom > visible.bottom && index !=1 ){
						tabs_holder.animate({
							top: '-='+(nextBottom-visible.bottom)+'px'
						}, {
							duration: d,
							complete: posUpdate,
							queue:false 
						});
					}
				}
			};								
			slidingTo(index);	
		}
		
		/* slide navigation for theme 5  
		*/
		function setSlidingToX(index, options){
			var tabs = $(options.pager);
			var tabs_holder = tabs.eq(0).parent();
			var tabs_container = tabs_holder.parent();
			if (tabs_container && tabs_holder){
				tabs_container.css({height: function(){
					return tabs_container.height();
				}});
				tabs_container.css({position: 'absolute'});
				tabs_holder.css({position: 'absolute'});
			}
			var viewport   = {};
			viewport.left  = 0;
			viewport.right = tabs_container.width();
			
			var visible   = {};
			visible.left  = viewport.left  - parseInt( tabs_holder.position().left );
			visible.right = viewport.right - parseInt( tabs_holder.position().left );
			
			var posUpdate = function(){
				visible.left  = viewport.left  - parseInt( tabs_holder.position().left );
				visible.right = viewport.right - parseInt( tabs_holder.position().left );
			};
			
			var slidingTo = function(index, d){
				if (!d){
					d = 500
				}
				if (index >= 0){
					if (index == 0){
						index = 1;
					}
					var prevLeft = tabs.eq(index-1).position().left;
					if (prevLeft < visible.left){
						tabs_holder.animate({
							left: '+='+(visible.left-prevLeft)+'px'
						}, {
							duration: d,
							complete: posUpdate,
							queue:false 
						});
					}
				}
				if (index < tabs.length){
					if (index == tabs.length-1){
						index = tabs.length-2;
					}
					var nextRight = tabs.eq(index+1).position().left + tabs.eq(index+1).width();
					if (nextRight > visible.right){
						tabs_holder.animate({
							left: '-='+(nextRight-visible.right)+'px'
						}, {
							duration: d,
							complete: posUpdate,
							queue:false 
						});
					}
				}
			};								
			slidingTo(index);	
		}
		<?php if(count($entries) > 1){?>
			$('.sl2-items', $element).cycle({	
				slideExpr: '.sl2-item',
				before: function(curr, next, options){
					$('.sl2-item', $element).eq(options.startingSlide).addClass('curr');
					if (typeof options.inited == 'undefined'){
						var slidingTo = options.startingSlide;
						options.inited = true;					
						if(typeof options.fxs != 'undefined'){						
							var tmp=[];
							var j=0;					
							for(var i=0;i<options.fxs.length;i++){
								if(options.fxs[i]=='none'){												
									continue;
								}
								
								tmp[j++]=options.fxs[i];							
							}
							if(tmp.length!=options.fxs.length){
								options.fxs=tmp;
							}						
						}										
					} else {
						var slidingTo = options.nextSlide;
						$('.sl2-item', $element).removeClass('curr');
						$('.sl2-item', $element).eq(options.nextSlide).addClass('curr');
					}
					<?php if($params->get('themes') != 'theme5'){?>
						setSlidingTo(slidingTo, options);
					<?php } else { ?>
						setSlidingToX(slidingTo, options);
					<?php }?>
				}, 
				fx: '<?php echo $params->get('effect', 'all'); ?>',
				speed: <?php echo $params->get('slideshow_speed', '500'); ?>,
				timeout: <?php echo $params->get('timer_speed', 0); ?>,
				pause:<?php echo (int)$params->get('pause_hover'); ?>,
				pauseOnPagerHover:<?php echo (int)$params->get('pause_hover'); ?>,
				startingSlide: <?php echo $params->get('start', 0); ?>,
				pager: '#sj_slideshowii_<?php echo $uniquied ;?> .slide-items .slide-item',
				pagerAnchorBuilder: function(i, el){
					return $('#sj_slideshowii_<?php echo $uniquied ;?>  .slide-items .slide-item:eq(' + i + ')');
				},
				updateActivePagerLink: function(pager, i, clsName){
					$(pager).removeClass('active').eq(i).addClass('active');
				},
				<?php if($params->get('themes') != 'theme5') {?>
				next: '#sj_slideshowii_<?php echo $uniquied ;?> .sl2-control .next',
				prev: '#sj_slideshowii_<?php echo $uniquied ;?> .sl2-control .previous',
				<?php } else {?>
				next: '#sj_slideshowii_<?php echo $uniquied ;?> .slide-next',
				prev: '#sj_slideshowii_<?php echo $uniquied ;?> .slide-previous',
				<?php }?>
				skipInitializationCallbacks: false,
				pagerEvent: 'click' 	
				
			});
			
			$('.play-pause', $element).bind('click',function(){
					if ( $(this).hasClass('pause') ){
						$(this).addClass('play');
						$(this).removeClass('pause');					
						$('.sl2-items', $element).cycle('pause');
					}else{
						$(this).removeClass('play');
						$(this).addClass('pause');
						$('.sl2-items', $element).cycle('resume');
					}
			});
			
			<?php if($params->get('play')==0): ?>
				$('.sl2-items', $element).cycle('pause');
			<?php endif; ?>
		<?php }?>
		})('#sj_slideshowii_<?php echo $uniquied ;?>');
	});
	//]]>
</script>
<?php } else {
	echo JText::_('Has no content to show!');	
}?>